class AttentiveStatisticsPooling(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  tdnn : __torch__.speakerlab.models.ecapa_tdnn.ECAPA_TDNN.___torch_mangle_10410.TDNNBlock
  tanh : __torch__.torch.nn.modules.activation.___torch_mangle_10411.Tanh
  conv : __torch__.speakerlab.models.ecapa_tdnn.ECAPA_TDNN.___torch_mangle_10413.Conv1d
  def forward(self: __torch__.speakerlab.models.ecapa_tdnn.ECAPA_TDNN.___torch_mangle_10414.AttentiveStatisticsPooling,
    argument_1: Tensor) -> Tensor:
    conv = self.conv
    tanh = self.tanh
    tdnn = self.tdnn
    L = ops.prim.NumToTensor(torch.size(argument_1, 2))
    _0 = int(L)
    _1 = int(L)
    _2 = int(L)
    _3 = annotate(number, L)
    _4 = ops.prim.NumToTensor(torch.size(argument_1, 0))
    lengths = torch.ones([int(_4)], dtype=None, layout=None, device=torch.device("cpu"), pin_memory=False)
    length = torch.mul(lengths, L)
    _5 = torch.arange(_3, dtype=6, layout=None, device=torch.device("cpu"), pin_memory=False)
    mask = torch.lt(torch.expand(_5, [1, _2]), torch.unsqueeze(length, 1))
    mask0 = torch.to(mask, torch.device("cpu"), 6)
    mask1 = torch.unsqueeze(mask0, 1)
    total = torch.to(torch.sum(mask1, [2], True), 6)
    m = torch.div(mask1, total)
    mean = torch.sum(torch.mul(m, argument_1), [2])
    _6 = torch.sub(argument_1, torch.unsqueeze(mean, 2))
    _7 = torch.sum(torch.mul(m, torch.pow(_6, 2)), [2])
    _8 = torch.clamp(_7, 9.9999999999999998e-13)
    std = torch.sqrt(_8)
    mean0 = torch.repeat(torch.unsqueeze(mean, 2), [1, 1, _1])
    std0 = torch.repeat(torch.unsqueeze(std, 2), [1, 1, _0])
    x = torch.cat([argument_1, mean0, std0], 1)
    _9 = (tanh).forward((tdnn).forward(x, ), )
    input = torch.masked_fill((conv).forward(_9, ), torch.eq(mask1, 0), -inf)
    m0 = torch.softmax(input, 2)
    mean1 = torch.sum(torch.mul(m0, argument_1), [2])
    _10 = torch.sub(argument_1, torch.unsqueeze(mean1, 2))
    _11 = torch.sum(torch.mul(m0, torch.pow(_10, 2)), [2])
    _12 = torch.clamp(_11, 9.9999999999999998e-13)
    std1 = torch.sqrt(_12)
    pooled_stats = torch.cat([mean1, std1], 1)
    return torch.unsqueeze(pooled_stats, 2)
